Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50158)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50159)
@@ -11573,9 +11804,9 @@
     xchg dx, ax                               ; 92
     test dx, di                               ; 85 fa
-    jne short 07d5bh                          ; 75 04
+    jne short 07f81h                          ; 75 04
     test ax, bx                               ; 85 d8
-    je short 07d5fh                           ; 74 04
+    je short 07f85h                           ; 74 04
     mov AL, strict byte 001h                  ; b0 01
-    jmp short 07d61h                          ; eb 02
+    jmp short 07f87h                          ; eb 02
     xor al, al                                ; 30 c0
     lea sp, [bp-004h]                         ; 8d 66 fc
@@ -11584,5 +11815,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-ahci_ctrl_extract_bits_:                     ; 0xf7d68 LB 0x1b
+ahci_ctrl_extract_bits_:                     ; 0xf7f8e LB 0x1b
     push si                                   ; 56
     push bp                                   ; 55
@@ -11592,12 +11823,12 @@
     and dx, cx                                ; 21 ca
     movzx cx, byte [bp+006h]                  ; 0f b6 4e 06
-    jcxz 07d7eh                               ; e3 06
+    jcxz 07fa4h                               ; e3 06
     shr dx, 1                                 ; d1 ea
     rcr ax, 1                                 ; d1 d8
-    loop 07d78h                               ; e2 fa
+    loop 07f9eh                               ; e2 fa
     pop bp                                    ; 5d
     pop si                                    ; 5e
     retn 00002h                               ; c2 02 00
-ahci_addr_to_phys_:                          ; 0xf7d83 LB 0x1e
+ahci_addr_to_phys_:                          ; 0xf7fa9 LB 0x1e
     push bx                                   ; 53
     push cx                                   ; 51
@@ -11610,5 +11841,5 @@
     sal ax, 1                                 ; d1 e0
     rcl dx, 1                                 ; d1 d2
-    loop 07d91h                               ; e2 fa
+    loop 07fb7h                               ; e2 fa
     xor cx, cx                                ; 31 c9
     add ax, bx                                ; 01 d8
@@ -11618,5 +11849,5 @@
     pop bx                                    ; 5b
     retn                                      ; c3
-ahci_port_cmd_sync_:                         ; 0xf7da1 LB 0xd5
+ahci_port_cmd_sync_:                         ; 0xf7fc7 LB 0xd5
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -11632,5 +11863,5 @@
     mov di, word [es:si+00260h]               ; 26 8b bc 60 02
     cmp AL, strict byte 0ffh                  ; 3c ff
-    je near 07e6eh                            ; 0f 84 aa 00
+    je near 08094h                            ; 0f 84 aa 00
     movzx cx, byte [es:si+00263h]             ; 26 0f b6 8c 63 02
     xor dx, dx                                ; 31 d2
@@ -11644,5 +11875,5 @@
     lea ax, [si+00080h]                       ; 8d 84 80 00
     mov dx, es                                ; 8c c2
-    call 07d83h                               ; e8 96 ff
+    call 07fa9h                               ; e8 96 ff
     mov es, [bp-00ah]                         ; 8e 46 f6
     mov word [es:si+008h], ax                 ; 26 89 44 08
@@ -11654,5 +11885,5 @@
     xor cx, cx                                ; 31 c9
     mov ax, di                                ; 89 f8
-    call 07ca5h                               ; e8 98 fe
+    call 07ecbh                               ; e8 98 fe
     lea ax, [si+00138h]                       ; 8d 84 38 01
     cwd                                       ; 99
@@ -11681,12 +11912,12 @@
     mov dx, si                                ; 89 f2
     mov ax, di                                ; 89 f8
-    call 07d2fh                               ; e8 e2 fe
+    call 07f55h                               ; e8 e2 fe
     test al, al                               ; 84 c0
-    je short 07e30h                           ; 74 df
+    je short 08056h                           ; 74 df
     mov bx, strict word 00001h                ; bb 01 00
     xor cx, cx                                ; 31 c9
     mov dx, si                                ; 89 f2
     mov ax, di                                ; 89 f8
-    call 07ca5h                               ; e8 48 fe
+    call 07ecbh                               ; e8 48 fe
     mov dx, word [bp-00ch]                    ; 8b 56 f4
     add dx, 00118h                            ; 81 c2 18 01
@@ -11694,5 +11925,5 @@
     xor cx, cx                                ; 31 c9
     mov ax, di                                ; 89 f8
-    call 07ce8h                               ; e8 7a fe
+    call 07f0eh                               ; e8 7a fe
     lea sp, [bp-006h]                         ; 8d 66 fa
     pop di                                    ; 5f
@@ -11701,5 +11932,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-ahci_cmd_data_:                              ; 0xf7e76 LB 0x1ca
+ahci_cmd_data_:                              ; 0xf809c LB 0x1ca
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -11725,5 +11956,5 @@
     mov ax, 00080h                            ; b8 80 00
     mov dx, word [bp-00ah]                    ; 8b 56 f6
-    call 0924ah                               ; e8 95 13
+    call 0946ah                               ; e8 8f 13
     mov es, [bp-00ah]                         ; 8e 46 f6
     mov word [es:si+00080h], 08027h           ; 26 c7 84 80 00 27 80
@@ -11741,5 +11972,5 @@
     shr bx, 1                                 ; d1 eb
     rcr ax, 1                                 ; d1 d8
-    loop 07ee8h                               ; e2 fa
+    loop 0810eh                               ; e2 fa
     mov es, [bp-00ah]                         ; 8e 46 f6
     mov byte [es:si+00085h], al               ; 26 88 84 85 00
@@ -11766,5 +11997,5 @@
     mov bx, word [bp-016h]                    ; 8b 5e ea
     xor cx, cx                                ; 31 c9
-    call 09219h                               ; e8 c8 12
+    call 09439h                               ; e8 c2 12
     push dx                                   ; 52
     push ax                                   ; 50
@@ -11774,5 +12005,5 @@
     mov ax, 0026ah                            ; b8 6a 02
     mov dx, word [bp-00ah]                    ; 8b 56 f6
-    call 0912bh                               ; e8 c4 11
+    call 09351h                               ; e8 c4 11
     mov es, [bp-00ah]                         ; 8e 46 f6
     movzx ax, byte [es:si+00263h]             ; 26 0f b6 84 63 02
@@ -11794,5 +12025,5 @@
     mov es, [bp-012h]                         ; 8e 46 ee
     cmp word [es:di+01ch], strict byte 00000h ; 26 83 7d 1c 00
-    je short 07fe0h                           ; 74 2c
+    je short 08206h                           ; 74 2c
     mov dx, word [es:di+01ch]                 ; 26 8b 55 1c
     dec dx                                    ; 4a
@@ -11813,17 +12044,17 @@
     movzx dx, byte [es:bx+00263h]             ; 26 0f b6 97 63 02
     cmp ax, dx                                ; 39 d0
-    jnc short 07ffah                          ; 73 03
+    jnc short 08220h                          ; 73 03
     inc ax                                    ; 40
-    jmp short 07feah                          ; eb f0
+    jmp short 08210h                          ; eb f0
     mov al, byte [bp-008h]                    ; 8a 46 f8
     cmp AL, strict byte 035h                  ; 3c 35
-    jne short 08007h                          ; 75 06
+    jne short 0822dh                          ; 75 06
     mov byte [bp-008h], 040h                  ; c6 46 f8 40
-    jmp short 0801bh                          ; eb 14
+    jmp short 08241h                          ; eb 14
     cmp AL, strict byte 0a0h                  ; 3c a0
-    jne short 08017h                          ; 75 0c
+    jne short 0823dh                          ; 75 0c
     or byte [bp-008h], 020h                   ; 80 4e f8 20
     or byte [es:bx+00083h], 001h              ; 26 80 8f 83 00 01
-    jmp short 0801bh                          ; eb 04
+    jmp short 08241h                          ; eb 04
     mov byte [bp-008h], 000h                  ; c6 46 f8 00
     or byte [bp-008h], 005h                   ; 80 4e f8 05
@@ -11831,9 +12062,9 @@
     mov ax, word [bp-00eh]                    ; 8b 46 f2
     mov dx, word [bp-00ch]                    ; 8b 56 f4
-    call 07da1h                               ; e8 75 fd
+    call 07fc7h                               ; e8 75 fd
     mov ax, word [bp-00eh]                    ; 8b 46 f2
     add ax, 0026ah                            ; 05 6a 02
     mov dx, word [bp-00ch]                    ; 8b 56 f4
-    call 091a4h                               ; e8 6c 11
+    call 093cah                               ; e8 6c 11
     lea sp, [bp-006h]                         ; 8d 66 fa
     pop di                                    ; 5f
@@ -11842,5 +12073,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-ahci_port_deinit_current_:                   ; 0xf8040 LB 0x144
+ahci_port_deinit_current_:                   ; 0xf8266 LB 0x144
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -11857,5 +12088,5 @@
     mov byte [bp-00ah], al                    ; 88 46 f6
     cmp AL, strict byte 0ffh                  ; 3c ff
-    je near 0817bh                            ; 0f 84 17 01
+    je near 083a1h                            ; 0f 84 17 01
     movzx dx, al                              ; 0f b6 d0
     sal dx, 007h                              ; c1 e2 07
@@ -11864,5 +12095,5 @@
     xor cx, cx                                ; 31 c9
     mov ax, si                                ; 89 f0
-    call 07ce8h                               ; e8 70 fc
+    call 07f0eh                               ; e8 70 fc
     movzx ax, byte [bp-00ah]                  ; 0f b6 46 f6
     sal ax, 007h                              ; c1 e0 07
@@ -11873,22 +12104,22 @@
     xor cx, cx                                ; 31 c9
     mov ax, si                                ; 89 f0
-    call 07d2fh                               ; e8 9d fc
+    call 07f55h                               ; e8 9d fc
     cmp AL, strict byte 001h                  ; 3c 01
-    je short 08078h                           ; 74 e2
+    je short 0829eh                           ; 74 e2
     mov cx, strict word 00020h                ; b9 20 00
     xor bx, bx                                ; 31 db
     mov ax, di                                ; 89 f8
     mov dx, word [bp-00ch]                    ; 8b 56 f4
-    call 0924ah                               ; e8 a7 11
+    call 0946ah                               ; e8 a1 11
     lea ax, [di+00080h]                       ; 8d 85 80 00
     mov cx, strict word 00040h                ; b9 40 00
     xor bx, bx                                ; 31 db
     mov dx, word [bp-00ch]                    ; 8b 56 f4
-    call 0924ah                               ; e8 98 11
+    call 0946ah                               ; e8 92 11
     lea ax, [di+00200h]                       ; 8d 85 00 02
     mov cx, strict word 00060h                ; b9 60 00
     xor bx, bx                                ; 31 db
     mov dx, word [bp-00ch]                    ; 8b 56 f4
-    call 0924ah                               ; e8 89 11
+    call 0946ah                               ; e8 83 11
     mov ax, word [bp-00eh]                    ; 8b 46 f2
     add ax, 00108h                            ; 05 08 01
@@ -11992,5 +12223,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-ahci_port_init_:                             ; 0xf8184 LB 0x206
+ahci_port_init_:                             ; 0xf83aa LB 0x206
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -12002,5 +12233,5 @@
     mov word [bp-00ah], dx                    ; 89 56 f6
     mov byte [bp-008h], bl                    ; 88 5e f8
-    call 08040h                               ; e8 a8 fe
+    call 08266h                               ; e8 a8 fe
     movzx dx, bl                              ; 0f b6 d3
     sal dx, 007h                              ; c1 e2 07
@@ -12010,5 +12241,5 @@
     mov bx, strict word 00011h                ; bb 11 00
     xor cx, cx                                ; 31 c9
-    call 07ce8h                               ; e8 36 fb
+    call 07f0eh                               ; e8 36 fb
     movzx di, byte [bp-008h]                  ; 0f b6 7e f8
     sal di, 007h                              ; c1 e7 07
@@ -12018,17 +12249,17 @@
     mov bx, 0c011h                            ; bb 11 c0
     xor cx, cx                                ; 31 c9
-    call 07d2fh                               ; e8 62 fb
+    call 07f55h                               ; e8 62 fb
     cmp AL, strict byte 001h                  ; 3c 01
-    je short 081b2h                           ; 74 e1
+    je short 083d8h                           ; 74 e1
     mov cx, strict word 00020h                ; b9 20 00
     xor bx, bx                                ; 31 db
     mov ax, si                                ; 89 f0
     mov dx, word [bp-00ah]                    ; 8b 56 f6
-    call 0924ah                               ; e8 6c 10
+    call 0946ah                               ; e8 66 10
     lea ax, [si+00080h]                       ; 8d 84 80 00
     mov cx, strict word 00040h                ; b9 40 00
     xor bx, bx                                ; 31 db
     mov dx, word [bp-00ah]                    ; 8b 56 f6
-    call 0924ah                               ; e8 5d 10
+    call 0946ah                               ; e8 57 10
     mov ax, si                                ; 89 f0
     add ah, 002h                              ; 80 c4 02
@@ -12037,5 +12268,5 @@
     xor bx, bx                                ; 31 db
     mov dx, word [bp-00ah]                    ; 8b 56 f6
-    call 0924ah                               ; e8 4a 10
+    call 0946ah                               ; e8 44 10
     lea ax, [di+00108h]                       ; 8d 85 08 01
     cwd                                       ; 99
@@ -12051,5 +12282,5 @@
     mov ax, word [bp-00ch]                    ; 8b 46 f4
     mov dx, word [bp-00ah]                    ; 8b 56 f6
-    call 07d83h                               ; e8 60 fb
+    call 07fa9h                               ; e8 60 fb
     mov es, [bp-00ah]                         ; 8e 46 f6
     mov bx, word [es:si+00260h]               ; 26 8b 9c 60 02
@@ -12096,5 +12327,5 @@
     mov ax, si                                ; 89 f0
     mov dx, word [bp-00ah]                    ; 8b 56 f6
-    call 07d83h                               ; e8 f4 fa
+    call 07fa9h                               ; e8 f4 fa
     mov es, [bp-00ah]                         ; 8e 46 f6
     mov bx, word [es:si+00260h]               ; 26 8b 9c 60 02
@@ -12201,5 +12432,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-@ahci_read_sectors:                          ; 0xf838a LB 0x94
+@ahci_read_sectors:                          ; 0xf85b0 LB 0x94
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -12210,15 +12441,15 @@
     sub di, strict byte 0000ch                ; 83 ef 0c
     cmp di, strict byte 00004h                ; 83 ff 04
-    jbe short 083aeh                          ; 76 0f
+    jbe short 085d4h                          ; 76 0f
     push di                                   ; 57
     push 00c66h                               ; 68 66 0c
     push 00c78h                               ; 68 78 0c
     push strict byte 00007h                   ; 6a 07
-    call 0190dh                               ; e8 62 95
+    call 01922h                               ; e8 51 93
     add sp, strict byte 00008h                ; 83 c4 08
     les bx, [bp+004h]                         ; c4 5e 04
     mov dx, word [es:bx+001eeh]               ; 26 8b 97 ee 01
     xor ax, ax                                ; 31 c0
-    call 07c77h                               ; e8 bc f8
+    call 07e9dh                               ; e8 bc f8
     mov es, [bp+006h]                         ; 8e 46 06
     add di, bx                                ; 01 df
@@ -12227,9 +12458,9 @@
     mov dx, word [es:di+001eeh]               ; 26 8b 95 ee 01
     xor ax, ax                                ; 31 c0
-    call 08184h                               ; e8 b1 fd
+    call 083aah                               ; e8 b1 fd
     mov bx, strict word 00025h                ; bb 25 00
     mov ax, di                                ; 89 f8
     mov dx, word [bp+006h]                    ; 8b 56 06
-    call 07e76h                               ; e8 98 fa
+    call 0809ch                               ; e8 98 fa
     mov es, [bp+006h]                         ; 8e 46 06
     mov bx, di                                ; 89 fb
@@ -12251,5 +12482,5 @@
     mov dx, word [es:bx+001eeh]               ; 26 8b 97 ee 01
     xor ax, ax                                ; 31 c0
-    call 07c8eh                               ; e8 7b f8
+    call 07eb4h                               ; e8 7b f8
     xor ax, ax                                ; 31 c0
     lea sp, [bp-004h]                         ; 8d 66 fc
@@ -12258,5 +12489,5 @@
     pop bp                                    ; 5d
     retn 00004h                               ; c2 04 00
-@ahci_write_sectors:                         ; 0xf841e LB 0x70
+@ahci_write_sectors:                         ; 0xf8644 LB 0x70
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -12268,15 +12499,15 @@
     sub bx, strict byte 0000ch                ; 83 eb 0c
     cmp bx, strict byte 00004h                ; 83 fb 04
-    jbe short 08446h                          ; 76 0f
+    jbe short 0866ch                          ; 76 0f
     push bx                                   ; 53
     push 00c97h                               ; 68 97 0c
     push 00c78h                               ; 68 78 0c
     push strict byte 00007h                   ; 6a 07
-    call 0190dh                               ; e8 ca 94
+    call 01922h                               ; e8 b9 92
     add sp, strict byte 00008h                ; 83 c4 08
     mov es, cx                                ; 8e c1
     mov dx, word [es:si+001eeh]               ; 26 8b 94 ee 01
     xor ax, ax                                ; 31 c0
-    call 07c77h                               ; e8 25 f8
+    call 07e9dh                               ; e8 25 f8
     mov es, cx                                ; 8e c1
     add bx, si                                ; 01 f3
@@ -12284,9 +12515,9 @@
     mov dx, word [es:si+001eeh]               ; 26 8b 94 ee 01
     xor ax, ax                                ; 31 c0
-    call 08184h                               ; e8 1e fd
+    call 083aah                               ; e8 1e fd
     mov bx, strict word 00035h                ; bb 35 00
     mov ax, si                                ; 89 f0
     mov dx, cx                                ; 89 ca
-    call 07e76h                               ; e8 06 fa
+    call 0809ch                               ; e8 06 fa
     mov es, cx                                ; 8e c1
     mov dx, word [es:si+00ah]                 ; 26 8b 54 0a
@@ -12294,5 +12525,5 @@
     mov dx, word [es:si+001eeh]               ; 26 8b 94 ee 01
     xor ax, ax                                ; 31 c0
-    call 07c8eh                               ; e8 0a f8
+    call 07eb4h                               ; e8 0a f8
     xor ax, ax                                ; 31 c0
     lea sp, [bp-002h]                         ; 8d 66 fe
@@ -12300,5 +12531,5 @@
     pop bp                                    ; 5d
     retn 00004h                               ; c2 04 00
-ahci_cmd_packet_:                            ; 0xf848e LB 0x173
+ahci_cmd_packet_:                            ; 0xf86b4 LB 0x173
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -12312,22 +12543,22 @@
     mov dx, strict word 0000eh                ; ba 0e 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 73 91
+    call 0161ch                               ; e8 4d 8f
     mov si, 00122h                            ; be 22 01
     mov word [bp-008h], ax                    ; 89 46 f8
     cmp byte [bp+00ah], 002h                  ; 80 7e 0a 02
-    jne short 084d4h                          ; 75 1f
-    mov bx, 00da6h                            ; bb a6 0d
+    jne short 086fah                          ; 75 1f
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 0c 94
+    call 018e1h                               ; e8 fb 91
     push 00caah                               ; 68 aa 0c
     push 00cbah                               ; 68 ba 0c
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 42 94
+    call 01922h                               ; e8 31 92
     add sp, strict byte 00006h                ; 83 c4 06
     mov ax, strict word 00001h                ; b8 01 00
-    jmp near 085f8h                           ; e9 24 01
+    jmp near 0881eh                           ; e9 24 01
     test byte [bp+004h], 001h                 ; f6 46 04 01
-    jne short 084ceh                          ; 75 f4
+    jne short 086f4h                          ; 75 f4
     mov ax, word [bp+006h]                    ; 8b 46 06
     mov dx, word [bp+008h]                    ; 8b 56 08
@@ -12335,5 +12566,5 @@
     sal ax, 1                                 ; d1 e0
     rcl dx, 1                                 ; d1 d2
-    loop 084e3h                               ; e2 fa
+    loop 08709h                               ; e2 fa
     mov es, [bp-008h]                         ; 8e 46 f8
     mov word [es:si], ax                      ; 26 89 04
@@ -12347,5 +12578,5 @@
     mov dx, word [bp+008h]                    ; 8b 56 08
     xor cx, cx                                ; 31 c9
-    call 091e0h                               ; e8 d0 0c
+    call 09400h                               ; e8 ca 0c
     mov word [es:si+00ah], ax                 ; 26 89 44 0a
     xor di, di                                ; 31 ff
@@ -12357,5 +12588,5 @@
     xor ax, ax                                ; 31 c0
     mov dx, word [bp-00ah]                    ; 8b 56 f6
-    call 07c77h                               ; e8 47 f7
+    call 07e9dh                               ; e8 47 f7
     mov es, [bp-008h]                         ; 8e 46 f8
     mov bx, word [bp-014h]                    ; 8b 5e ec
@@ -12364,5 +12595,5 @@
     mov dx, word [es:si+001eeh]               ; 26 8b 94 ee 01
     xor ax, ax                                ; 31 c0
-    call 08184h                               ; e8 3c fc
+    call 083aah                               ; e8 3c fc
     movzx ax, byte [bp-006h]                  ; 0f b6 46 fa
     push ax                                   ; 50
@@ -12371,5 +12602,5 @@
     mov ax, 000c0h                            ; b8 c0 00
     mov dx, word [bp-00ah]                    ; 8b 56 f6
-    call 09257h                               ; e8 fb 0c
+    call 09477h                               ; e8 f5 0c
     mov es, [bp-008h]                         ; 8e 46 f8
     mov word [es:si+014h], di                 ; 26 89 7c 14
@@ -12378,5 +12609,5 @@
     mov ax, word [es:si+01ah]                 ; 26 8b 44 1a
     test ax, ax                               ; 85 c0
-    je short 0859ah                           ; 74 27
+    je short 087c0h                           ; 74 27
     dec ax                                    ; 48
     mov es, [bp-00ah]                         ; 8e 46 f6
@@ -12391,5 +12622,5 @@
     mov ax, si                                ; 89 f0
     mov dx, word [bp-008h]                    ; 8b 56 f8
-    call 07e76h                               ; e8 d1 f8
+    call 0809ch                               ; e8 d1 f8
     les bx, [bp-00eh]                         ; c4 5e f2
     mov ax, word [es:bx+004h]                 ; 26 8b 47 04
@@ -12414,11 +12645,11 @@
     mov ax, word [bp-00eh]                    ; 8b 46 f2
     mov dx, word [bp-00ch]                    ; 8b 56 f4
-    call 07c8eh                               ; e8 aa f6
+    call 07eb4h                               ; e8 aa f6
     les bx, [bp-00eh]                         ; c4 5e f2
     mov ax, word [es:bx+006h]                 ; 26 8b 47 06
     or ax, word [es:bx+004h]                  ; 26 0b 47 04
-    jne short 085f6h                          ; 75 05
+    jne short 0881ch                          ; 75 05
     mov ax, strict word 00004h                ; b8 04 00
-    jmp short 085f8h                          ; eb 02
+    jmp short 0881eh                          ; eb 02
     xor ax, ax                                ; 31 c0
     lea sp, [bp-004h]                         ; 8d 66 fc
@@ -12427,5 +12658,5 @@
     pop bp                                    ; 5d
     retn 0000ch                               ; c2 0c 00
-ahci_port_detect_device_:                    ; 0xf8601 LB 0x3d1
+ahci_port_detect_device_:                    ; 0xf8827 LB 0x3d1
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -12439,8 +12670,8 @@
     movzx cx, bl                              ; 0f b6 cb
     mov bx, cx                                ; 89 cb
-    call 08184h                               ; e8 69 fb
+    call 083aah                               ; e8 69 fb
     mov dx, strict word 0000eh                ; ba 0e 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 f8 8f
+    call 0161ch                               ; e8 d2 8d
     mov word [bp-020h], ax                    ; 89 46 e0
     mov si, 00122h                            ; be 22 01
@@ -12515,12 +12746,12 @@
     mov bx, strict word 0000fh                ; bb 0f 00
     xor cx, cx                                ; 31 c9
-    call 07d68h                               ; e8 90 f6
+    call 07f8eh                               ; e8 90 f6
     cmp ax, strict word 00003h                ; 3d 03 00
-    jne near 089cah                           ; 0f 85 eb 02
+    jne near 08bf0h                           ; 0f 85 eb 02
     mov es, [bp-00eh]                         ; 8e 46 f2
     mov al, byte [es:si+001edh]               ; 26 8a 84 ed 01
     mov byte [bp-00ah], al                    ; 88 46 f6
     cmp AL, strict byte 004h                  ; 3c 04
-    jnc near 089cah                           ; 0f 83 da 02
+    jnc near 08bf0h                           ; 0f 83 da 02
     mov dx, word [bp-01ch]                    ; 8b 56 e4
     add dx, 00118h                            ; 81 c2 18 01
@@ -12529,5 +12760,5 @@
     mov bx, strict word 00010h                ; bb 10 00
     xor cx, cx                                ; 31 c9
-    call 07ca5h                               ; e8 9e f5
+    call 07ecbh                               ; e8 9e f5
     mov ax, word [bp-01ch]                    ; 8b 46 e4
     add ax, 00124h                            ; 05 24 01
@@ -12555,7 +12786,7 @@
     add cl, 00ch                              ; 80 c1 0c
     test dx, dx                               ; 85 d2
-    jne near 0891ch                           ; 0f 85 d5 01
+    jne near 08b42h                           ; 0f 85 d5 01
     cmp bx, 00101h                            ; 81 fb 01 01
-    jne near 0891ch                           ; 0f 85 cd 01
+    jne near 08b42h                           ; 0f 85 cd 01
     mov es, [bp-00eh]                         ; 8e 46 f2
     db  066h, 026h, 0c7h, 004h, 000h, 000h, 000h, 000h
@@ -12569,5 +12800,5 @@
     mov ax, si                                ; 89 f0
     mov dx, word [bp-020h]                    ; 8b 56 e0
-    call 07e76h                               ; e8 fc f6
+    call 0809ch                               ; e8 fc f6
     mov byte [bp-00ch], cl                    ; 88 4e f4
     test byte [bp-00228h], 080h               ; f6 86 d8 fd 80
@@ -12585,7 +12816,7 @@
     mov word [bp-014h], dx                    ; 89 56 ec
     cmp dx, 00fffh                            ; 81 fa ff 0f
-    jne short 087bdh                          ; 75 10
+    jne short 089e3h                          ; 75 10
     cmp di, strict byte 0ffffh                ; 83 ff ff
-    jne short 087bdh                          ; 75 0b
+    jne short 089e3h                          ; 75 0b
     mov di, word [bp-00160h]                  ; 8b be a0 fe
     mov dx, word [bp-0015eh]                  ; 8b 96 a2 fe
@@ -12616,19 +12847,19 @@
     mov al, byte [bp-00ah]                    ; 8a 46 f6
     cmp AL, strict byte 001h                  ; 3c 01
-    jc short 08828h                           ; 72 0c
-    jbe short 08830h                          ; 76 12
+    jc short 08a4eh                           ; 72 0c
+    jbe short 08a56h                          ; 76 12
     cmp AL, strict byte 003h                  ; 3c 03
-    je short 08838h                           ; 74 16
+    je short 08a5eh                           ; 74 16
     cmp AL, strict byte 002h                  ; 3c 02
-    je short 08834h                           ; 74 0e
-    jmp short 08881h                          ; eb 59
+    je short 08a5ah                           ; 74 0e
+    jmp short 08aa7h                          ; eb 59
     test al, al                               ; 84 c0
-    jne short 08881h                          ; 75 55
+    jne short 08aa7h                          ; 75 55
     mov DL, strict byte 040h                  ; b2 40
-    jmp short 0883ah                          ; eb 0a
+    jmp short 08a60h                          ; eb 0a
     mov DL, strict byte 048h                  ; b2 48
-    jmp short 0883ah                          ; eb 06
+    jmp short 08a60h                          ; eb 06
     mov DL, strict byte 050h                  ; b2 50
-    jmp short 0883ah                          ; eb 02
+    jmp short 08a60h                          ; eb 02
     mov DL, strict byte 058h                  ; b2 58
     mov al, dl                                ; 88 d0
